import urllib, urllib2, re, xbmcplugin, xbmcgui, xbmc, sys, os

# plugin constants
__plugin__ = "Grooveshark"
__author__ = "Stephen Denham"
__url__ = ""
__svn_url__ = ""
__version__ = "0.0.1"
__svn_revision__ = ""
__XBMC_Revision__ = ""

MODE_SEARCH_SONGS = 1
MODE_SEARCH_ALBUMS = 2
MODE_SEARCH_ARTISTS = 3
MODE_POPULAR = 4
MODE_FAVORITES = 5
MODE_PLAYLISTS = 6
MODE_ALBUM = 7
MODE_ARTIST = 8
MODE_PLAYLIST = 9
MODE_SONG = 10
MODE_FAVORITE = 11
MODE_UNFAVORITE = 12

songsearchlimit = 25
albumsearchlimit = 15
artistsearchlimit = 15

lastID = 0

rootDir = os.getcwd()

resDir = xbmc.translatePath(os.path.join(rootDir, 'resources'))
libDir = xbmc.translatePath(os.path.join(resDir,  'lib'))
imgDir = xbmc.translatePath(os.path.join(resDir,  'img'))

sys.path.append (libDir)
from GrooveAPI import *
groovesharkApi = GrooveAPI()

class _Info:
    def __init__( self, *args, **kwargs ):
        self.__dict__.update( kwargs )

class Groveshark:

    albumImg = xbmc.translatePath(os.path.join(imgDir,  'album.png'))
    artistImg = xbmc.translatePath(os.path.join(imgDir,  'artist.png'))
    favoritesImg = xbmc.translatePath(os.path.join(imgDir,  'favorites.png'))
    playlistImg = xbmc.translatePath(os.path.join(imgDir,  'playlist.png'))
    popularImg = xbmc.translatePath(os.path.join(imgDir,  'popular.png'))
    songImg = xbmc.translatePath(os.path.join(imgDir,  'song.png'))

    songsearchlimit = xbmcplugin.getSetting('songsearchlimit')
    albumsearchlimit = xbmcplugin.getSetting('albumsearchlimit')
    artistsearchlimit = xbmcplugin.getSetting('artistsearchlimit')
   
    def __init__( self ):
        self._handle = int(sys.argv[1])
    
    def categories(self):
        userid = self._get_login()
        self._addDir('Search songs', '', MODE_SEARCH_SONGS, self.songImg, 0)
        self._addDir('Search albums', '', MODE_SEARCH_ALBUMS, self.albumImg, 0)
        self._addDir('Search artists', '', MODE_SEARCH_ARTISTS, self.artistImg, 0)
        self._addDir('Popular', '', MODE_POPULAR, self.popularImg, 0)
        if (userid != 0):
            self._addDir('Favorites', '', MODE_FAVORITES, self.favoritesImg, 0)
            self._addDir('Playlists', '', MODE_PLAYLISTS, self.playlistImg, 0)
                           
    def searchSongs(self):
        query = self._get_keyboard(default="", heading="Search songs")
        if (query): 
            songs = groovesharkApi.searchSongs(query, limit = songsearchlimit)
            if (len(songs) > 0):
                self._get_songs(songs)
            else:
                dialog = xbmcgui.Dialog()
                dialog.ok('Grooveshark', 'No matching songs.')
                self.categories()
    
    def searchAlbums(self):
        query = self._get_keyboard(default="", heading="Search albums")
        if (query): 
            albums = groovesharkApi.searchAlbums(query, limit = albumsearchlimit)
            if (len(albums) > 0):
                self._get_albums(albums)
            else:
                dialog = xbmcgui.Dialog()
                dialog.ok('Grooveshark', 'No matching albums.')
                self.categories()
    
    def searchArtists(self):
        query = self._get_keyboard(default="", heading="Search artists")
        if (query): 
            artists = groovesharkApi.searchArtists(query, limit = artistsearchlimit)
            if (len(artists) > 0):
                self._get_artists(artists)
            else:
                dialog = xbmcgui.Dialog()
                dialog.ok('Grooveshark', 'No matching artists.')
                self.categories()
                    
    def favorites(self):
        userid = self._get_login()
        if (userid != 0):
            favorites = groovesharkApi.userGetFavoriteSongs(userid)
            if (len(favorites) > 0):
                self._get_songs(favorites)
            else:
                dialog = xbmcgui.Dialog()
                dialog.ok('Grooveshark', 'You have no favorites.')
                self.categories()
    
    def popular(self):
        popular = groovesharkApi.popularGetSongs(limit = songsearchlimit)
        if (len(popular) > 0):
            self._get_songs(popular)
        else:
            dialog = xbmcgui.Dialog()
            dialog.ok('Grooveshark', 'No popular songs.')
            self.categories()
                 
    def playlists(self):
        userid = self._get_login()
        if (userid != 0):
            playlists = groovesharkApi.userGetPlaylists()
            if (len(playlists) > 0):
                self._get_playlists(playlists)
            else:
                dialog = xbmcgui.Dialog()
                dialog.ok('Grooveshark', 'You have no playlists.')
                self.categories()
                
    def favorite(self, songid):
        userid = self._get_login()
        if (userid != 0):
            xbmc.log("Favorite song: " + str(songid))
            groovesharkApi.favoriteSong(songID = songid)
        else:
            dialog = xbmcgui.Dialog()
            dialog.ok('Grooveshark', 'You must be logged in', 'to add favorites.')
    
    def unfavorite(self, songid):
        userid = self._get_login()
        if (userid != 0):
            xbmc.log("Unfavorite song: " + str(songid))
            groovesharkApi.unfavoriteSong(songID = songid)
        else:
            dialog = xbmcgui.Dialog()
            dialog.ok('Grooveshark', 'You must be logged in', 'to remove favorites.')
    
    def album(self,albumid):
        album = groovesharkApi.albumGetSongs(albumId = albumid, limit = songsearchlimit)
        self._get_songs(album)
    
    def artist(self, artistid):
        albums = groovesharkApi.artistGetAlbums(artistId = artistid, limit = albumsearchlimit)
        self._get_albums(albums)
    
    def playlist(self, playlistid):
        userid = self._get_login()
        if (userid != 0):
            songs = groovesharkApi.playlistGetSongs(playlistId = playlistid, limit = songsearchlimit)
            self._get_songs(songs)
        else:
            dialog = xbmcgui.Dialog()
            dialog.ok('Grooveshark', 'You must be logged in', 'to get playlists.')
            
    def song(self, url, name, album, artist, duration):
        xbmc.log("Playing: " + url)
        songItem = xbmcgui.ListItem(name + " - " + artist, path=url)
        songItem.setInfo( type="Music", infoLabels={ "Title": name, "Duration": duration, "Album": album, "Artist": artist} )
        xbmc.Player().stop()
        xbmc.Player(xbmc.PLAYER_CORE_PAPLAYER).play(url, songItem, False)
        
    def _get_keyboard(self, default="", heading="", hidden=False):
            kb = xbmc.Keyboard(default, heading, hidden)
            kb.doModal()
            if (kb.isConfirmed()):
                return unicode(kb.getText(), "utf-8")
            return ''
    
    def _get_login(self):
        username = xbmcplugin.getSetting('username')
        password = xbmcplugin.getSetting('password')
        if (username == "" or password == ""):
            dialog = xbmcgui.Dialog()
            dialog.ok('Grooveshark', 'Unable to login.', 'Check username and password in settings.')
            return 0
        else:
            if groovesharkApi.loggedInStatus() == 1:
                groovesharkApi.logout()
            try:    
                userid = groovesharkApi.loginExt(username, password)
            except (LoginUnknownError):
                userid = 0
            if (userid != 0):
                xbmc.log("Logged in")
                return userid
            else:
                dialog = xbmcgui.Dialog()
                dialog.ok('Grooveshark', 'Unable to login.', 'Check username and password in settings.')
                return 0
    
    def _get_songs(self, songs):
        xbmc.log("Found " + str(len(songs)) + " songs...")
        i = 0
        while i < len(songs):
            song = songs[i]
            songName = song[0]
            songID = song[1]
            songDuration = song[2]
            songAlbum = song[3]
            songArtist = song[6]
            songImage = song[9]
            xbmc.log(songName)
            self._addSong(songID, songName, groovesharkApi.getStreamURL(songID), songDuration, songAlbum, songArtist, songImage)
            i = i + 1
        xbmcplugin.setContent(self._handle, 'songs')
        xbmcplugin.addSortMethod(self._handle, xbmcplugin.SORT_METHOD_TITLE_IGNORE_THE)
            
    def _get_albums(self, albums):
        xbmc.log("Found " + str(len(albums)) + " albums...")
        i = 0
        while i < len(albums):
            album = albums[i]
            albumArtistName = album[0]
            albumName = album[2]
            albumID = album[3]
            albumImage = album[4]
            xbmc.log(albumName)
            self._addDir(albumName + " - " + albumArtistName, '', MODE_ALBUM, albumImage, albumID)
            i = i + 1
        xbmcplugin.setContent(self._handle, 'albums')
        xbmcplugin.addSortMethod(self._handle, xbmcplugin.SORT_METHOD_ALBUM_IGNORE_THE)
            
    def _get_artists(self, artists):
        xbmc.log("Found " + str(len(artists)) + " artists...")
        i = 0
        while i < len(artists):
            artist = artists[i]
            artistName = artist[0]
            artistID = artist[1]
            xbmc.log(artistName)
            self._addDir(artistName, '', MODE_ARTIST, self.artistImg, artistID)
            i = i + 1
        xbmcplugin.setContent(self._handle, 'artists')
        xbmcplugin.addSortMethod(self._handle, xbmcplugin.SORT_METHOD_ARTIST_IGNORE_THE)
            
    def _get_playlists(self, playlists):
        xbmc.log("Found " + str(len(playlists)) + " playlists...")
        i = 0
        while i < len(playlists):
            playlist = playlists[i]
            playlistName = playlist[0]
            playlistID = playlist[1]
            xbmc.log(playlistName)
            self._addDir(playlistName, '', MODE_PLAYLIST, self.playlistImg, playlistID, )
            i = i + 1  
        xbmcplugin.setContent(self._handle, 'files')
        xbmcplugin.addSortMethod(self._handle, xbmcplugin.SORT_METHOD_PLAYLIST_ORDER)
        
    def _addSong(self, songid, songname, songurl, songduration, songalbum, songartist, songimage):
        u=sys.argv[0]+"?url="+urllib.quote_plus(songurl)+"&mode="+str(MODE_SONG)+"&name="+urllib.quote_plus(songname)+"&id="+str(songid) \
        +"&album="+urllib.quote_plus(songalbum) \
        +"&artist="+urllib.quote_plus(songartist) \
        +"&duration="+str(songduration)
        songItem = xbmcgui.ListItem(songname + " - " + songartist, iconImage=songimage, thumbnailImage=songimage, path=songurl)
        songItem.setInfo( type="Music", infoLabels={ "Title": songname, "Duration": songduration, "Album": songalbum, "Artist": songartist} )
        fav=sys.argv[0]+"?url="+urllib.quote_plus(songurl)+"&mode="+str(MODE_FAVORITE)+"&name="+urllib.quote_plus(songname)+"&id="+str(songid)
        unfav=sys.argv[0]+"?url="+urllib.quote_plus(songurl)+"&mode="+str(MODE_UNFAVORITE)+"&name="+urllib.quote_plus(songname)+"&id="+str(songid)
        menuItems = []
        menuItems.append(("Grooveshark Favorite",      "XBMC.RunPlugin("+fav+")"))
        menuItems.append(("Not Grooveshark Favorite", "XBMC.RunPlugin("+unfav+")"))
        songItem.addContextMenuItems(menuItems, replaceItems=False)
        return xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=songItem,isFolder=False)
      
    def _addDir(self, name, url, mode, iconimage, id):
        u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.quote_plus(name)+"&id="+str(id)
        dir=xbmcgui.ListItem(name, iconImage=iconimage, thumbnailImage=iconimage)
        dir.setInfo( type="Music", infoLabels={ "Title": name } )
        # Codes from http://xbmc-scripting.googlecode.com/svn/trunk/Script%20Templates/common/gui/codes.py
        menuItems = []
        menuItems.append(("Select", "XBMC.executebuiltin(Action(7))"))
        dir.addContextMenuItems(menuItems, replaceItems=True)
        return xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=dir,isFolder=True)
   
def get_params():
    param=[]
    paramstring=sys.argv[2]
    if len(paramstring)>=2:
        params=sys.argv[2]
        cleanedparams=params.replace('?','')
        if (params[len(params)-1]=='/'):
            params=params[0:len(params)-2]
        pairsofparams=cleanedparams.split('&')
        param={}
        for i in range(len(pairsofparams)):
            splitparams={}
            splitparams=pairsofparams[i].split('=')
            if (len(splitparams))==2:
                param[splitparams[0]]=splitparams[1]
    print param              
    return param
        
grooveshark = Groveshark();
    
params=get_params()
url=None
name=None
mode=None
id=None

try: url=urllib.unquote_plus(params["url"]) 
except: pass
try: name=urllib.unquote_plus(params["name"])
except: pass
try: mode=int(params["mode"])
except: pass
try: id=int(params["id"])
except: pass

if (id > 0):
    lastID = id

if mode==None:
    grooveshark.categories()
       
elif mode==MODE_SEARCH_SONGS:
    grooveshark.searchSongs()
    
elif mode==MODE_SEARCH_ALBUMS:
    grooveshark.searchAlbums()

elif mode==MODE_SEARCH_ARTISTS:
    grooveshark.searchArtists()

elif mode==MODE_POPULAR:
    grooveshark.popular()

elif mode==MODE_PLAYLISTS:
    grooveshark.playlists()

elif mode==MODE_FAVORITES:
    grooveshark.favorites()

elif mode==MODE_SONG:
    try: name=urllib.unquote_plus(params["name"])
    except: pass
    try: album=urllib.unquote_plus(params["album"])
    except: pass
    try: artist=urllib.unquote_plus(params["artist"])
    except: pass
    try: duration=int(params["duration"])
    except: pass
    grooveshark.song(url, name, album, artist, duration)

elif mode==MODE_ARTIST:
    grooveshark.artist(lastID)
    
elif mode==MODE_ALBUM:
    grooveshark.album(lastID)
    
elif mode==MODE_PLAYLIST:
    grooveshark.playlist(lastID)
    
elif mode==MODE_FAVORITE:
    grooveshark.favorite(lastID)

elif mode==MODE_UNFAVORITE:
    grooveshark.unfavorite(lastID)
    
if (mode < MODE_SONG):    
    xbmcplugin.endOfDirectory(int(sys.argv[1]))
